ComponentCollection = {}
ComponentCollection.__index = ComponentCollection

local types = 0

function ComponentCollection:add(component)
	local bridge = self.bridge
	local context = bridge.context

	component.entity = self.entity
	
	types = types + 1
	local typeName = "LuaDynamicType" .. types

	local typeId = Constants.NoType
	
	-- If component is derived from dynamic component then
	-- typeId = bridge.getTypeId(typeName)
	-- end

	if typeId == Constants.NoType then
		local mask = 0
		local messagesById = {}

		for key,value in pairs(component) do
			if type(value) == "function" then
				local messageId = bridge.getMessageId(context, key)

				if messageId ~= -1 then
					mask = mask | 1 << messageId
					messagesById[messageId] = value
				end
			end
		end

		bridge.registerDynamicType(context, typeName, mask)
		typeId = bridge.getTypeId(typeName)
		bridge.addComponent(context, self.entity.id, typeId)

		function dispatch(id, data)
			messagesById[id](component, data)
		end

		bridge.registerMessageCallback(context, self.entity.id, typeId, dispatch)
	end
end

function ComponentCollection.new(bridge, entity)
	local c = {
		entity = entity,
		bridge = bridge
	}
	setmetatable(c, ComponentCollection)
	return c
end
