SurfaceOut surfaceFunction(VertexIn In)
{
  SurfaceOut Out = (SurfaceOut)0;

  Out.Specular = float3(1, 1, 1);
  Out.SpecularPower = 80.f;

#ifdef COGS_CLOSED_TRANSPARENT_MATERIAL_DIFFUSE_MAP
  float v = texCoordRange.y * (In.TexCoord.x - texCoordRange.x);
  float w = texCoordRange.w * (In.TexCoord.y - texCoordRange.z);
  float4 color = diffuseMap.Sample(diffuseMapSampler, float2(v, w), 0);
  Out.Color = saturate(float4(color.rgb, color.a));
#else
  Out.Color = diffuseColor;
#endif

  Out.Normal = normalize(In.Facing ? In.Normal : -In.Normal);

  return Out;
}
