cbuffer Globals
{
  float4x4 projectionMatrix;
  float4x4 viewMatrix;
  float4x4 worldMatrix;

  float4 diffuseColor;
};

struct VS_INPUT
{
  float4 Position : POSITION0;
};

struct VS_OUTPUT
{
  float4 Position : SV_Position;
};

VS_OUTPUT main(VS_INPUT Input)
{
  VS_OUTPUT Out = (VS_OUTPUT)0;

  float4x4 worldViewMatrix = mul(worldMatrix, viewMatrix);
  float4x4 worldViewProjectionMatrix = mul(worldViewMatrix, projectionMatrix);
  Out.Position = mul(Input.Position, worldViewProjectionMatrix);

  return Out;
}
