cbuffer ImguiBuffer : register(b0)
{
  float4x4 ProjectionMatrix;
  int ShowAlpha;
  int TexMode;
  int Offset;
};

struct VS_INPUT
{
  float2 pos : POSITION0;
  float4 col : COLOR0;
  float2 uv  : TEXCOORD0;
};

struct PS_INPUT
{
  float4 pos : SV_Position;
  float4 col : COLOR0;
  float2 uv  : TEXCOORD0;
};

PS_INPUT main(VS_INPUT input)
{
  PS_INPUT output;
  output.pos = mul(float4(input.pos.xy, 0.0, 1.0), ProjectionMatrix);
  output.col = float4(pow(abs(input.col.rgb), 2.2), input.col.a);

  //if (ShowAlpha == 1)
  //{
  //  output.col.a = -1;
  //}

  output.uv = input.uv;
  return output;
}
