#if defined(COGS_TRANSPARENT_SHADOWS)
#include "BlueNoise.hlsl"
#endif

void main(VertexIn In, float4 ScreenPos: SV_Position)
{
#if defined(COGS_ALPHA_TEST_DISCARD) || defined(COGS_ALPHA_TO_COVERAGE) || defined(COGS_TRANSPARENT_SHADOWS)
  SurfaceOut surface = SURFACE_FUNCTION(In);
#endif

#if defined(COGS_ALPHA_TEST_DISCARD) || defined(COGS_ALPHA_TO_COVERAGE)
  if (surface.Color.a < alphaThreshold) discard;
#endif

#if defined(COGS_TRANSPARENT_SHADOWS)
  int2 noise_pos = ScreenPos.xy;
  //noise_pos += int2(objectId&0x3f, objectId>>6);
  float dither = blueNoiseStable(noise_pos);
  if (surface.Color.a < dither && surface.Color.a != 1.0) discard;
#endif
}
