#include "Engine/TransparencyCommon.hlsl"

#define MAX_SAMPLES 60

#ifdef COGS_REVERSE_DEPTH
#define COGS_CLEAR_DEPTH 0.0
#else
#define COGS_CLEAR_DEPTH 1.0
#endif

struct VertexIn
{
  float4 Position : SV_Position;
  float4 ScreenPosition : TEXCOORD0;
  float2 TexCoords : TEXCOORD1;
};

struct PixelOut
{
  float4 Color : SV_Target;
};

float4 blend(float4 front, float4 back)
{
  float a = (1.0 - front.a)*back.a;

  float4 result;
  result.rgb = front.rgb + a*back.rgb;
  result.a = min(1, front.a + a);

  return result;
}
