uniform vec4 lodLevels;
uniform vec2 offsetFromOrigin;

uniform vec4 texCoordWorldTransform;
uniform vec4 texCoordUnitTransform;
uniform vec4 texCoordLinearTransform;

vec3 snapAdaptivePlanarGridEdges(vec3 pos)
{
  if (pos.z != 0.0) {
    float l = dot(vec4(equal(vec4(floor(pos.z)), vec4(1, 2, 3, 4))),
                  vec4(lodLevels));
    float s = exp2(l);
    
    pos.xy = (1.0 / s)*floor(s*pos.xy + fract(pos.zz));
    pos.z = 0.0;
  }

  return pos;
}

vec2 getTexCoordWorld(vec2 v)
{
  vec2 z = texCoordWorldTransform.xy*v;

  vec4 m = texCoordLinearTransform;
  vec2 q = vec2(m.x*z.x + m.z*z.y,
                    m.y*z.x + m.w*z.y);

  return q + texCoordWorldTransform.zw;
}

vec2 getTexCoordUnit(vec2 v)
{
  vec2 z = texCoordUnitTransform.xy*v;

    vec4 m = texCoordLinearTransform;
    vec2 q = vec2(m.x*z.x + m.z*z.y,
    m.y*z.x + m.w*z.y);

  return q + texCoordUnitTransform.zw;
}
