#version 100
#extension GL_EXT_shader_texture_lod : enable
precision highp float;
precision highp int;

varying vec2 NormalizedCoords;

uniform vec4 color;
uniform float brightness;
uniform sampler2D colorTexture;

void main()
{
  vec4 colorIn = texture2D(colorTexture, NormalizedCoords);

  float lightness = clamp(colorIn.r * 0.2126 + colorIn.g * 0.7152 + colorIn.b * 0.0722, 0.0, 1.0);

  gl_FragColor = vec4(brightness * color.rgb * lightness, 1);
}
