#ifdef COGS_REVERSE_DEPTH
#define COGS_CLEAR_DEPTH 0.0
#else
#define COGS_CLEAR_DEPTH 1.0
#endif

cbuffer ResolveParameters
{
  uint msaaSamples;
};

Texture2DMS<float> msaaDepthTexture;

float4 main(float4 ScreenPos : SV_Position) : SV_Target
{
  float d = COGS_CLEAR_DEPTH;
  for (int i=0; i<msaaSamples; ++i) {
#ifdef COGS_REVERSE_DEPTH
    d = max(d, msaaDepthTexture.Load(int2(ScreenPos.xy), i));
#else
    d = min(d, msaaDepthTexture.Load(int2(ScreenPos.xy), i));
#endif
  }
  return float4(d, 0, 0, 0);
}
